// Area.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _AREA_H
#define _AREA_H

#include <list>
#include "Object.h"


namespace db { class Area; }
class Database;

typedef std::list<db::Area *> areas_t;

/** Database table Area
	\ingroup db */
class Area : public Object
{
public:
	Area(Database& ,long num);
	Area(Database& ,const std::string& name);
	~Area();

	bool Exists();
	void Save();

	int GetWidth();
	int GetHeight();
	long GetNum();
	void SetWidth(int);
	void SetHeight(int);
	void SetName(const std::string& name);
	const std::string& GetName();

	void VerifyTerrain();

static	db::Area *GetArea(Database&,long num);
static	db::Area *GetArea(Database&,const std::string& name);

	void GetAreaBorders(int ch_z,int& xmin,int& xmax,int &ymin,int &ymax);

private:
	db::Area *m_area;
static	areas_t m_areas;
};




#endif // _AREA_H
