// Clear.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "Clear.h"
#include "Player.h"
#include "Area.h"
#include "Chunk.h"
#include "InSocket.h"


void Clear::Execute(InSocket *from,const std::string& params,Parse&)
{
	Database& db = from -> GetDatabase();
	Player pl(db, from -> GetAccountName());
	Area area(db, pl.GetArea());
	Chunk chunk(db, area, pl.GetChunk());

	char fromchar = chunk.Get(pl.GetChunkX(),pl.GetChunkY());
	if (' ' != fromchar)
	{
		chunk.Fill(pl.GetChunkX(),pl.GetChunkY(),fromchar,' ');
		chunk.Save();
		from -> Send("Ok.\n");
	}
	else
	{
		from -> Send("Can't fill with same terrain.\n");
	}
	from -> SetPrompt();
}


