// Editor.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _EDITOR_H
#define _EDITOR_H

#include <vector>
#include <string>
#include "Command.h"


class Database;

/** Line-based Text Editor class.
	\ingroup command */
class Editor : public Command
{
public:
	typedef enum
	{
		EDIT_ROOM_DESCRIPTION = 1,
	} editor_t;

public:
	Editor(InSocket *from,editor_t type);
	~Editor();

	void Init();
	void Save();

	void Execute(InSocket *,const std::string& params,Parse&) {}
	void OnLine(InSocket *,const std::string& line,int state);

	std::string Category() { return "General"; }

	void SetPrompt(int state);

private:
	void AddLine(const std::string& x) { m_edit.push_back(x); }
	InSocket *m_from;
	editor_t m_type;
	std::vector<std::string> m_edit;
	size_t m_line;
	std::string m_prev;
};




#endif // _EDITOR_H
