// Enter.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "Enter.h"
#include "Area.h"
#include "Player.h"
#include "Chunk.h"
#include "Chunkinfo.h"
#include "InSocket.h"
#include "Look.h"
#include "Portal.h"


void Enter::Execute(InSocket *from,const std::string& params,Parse&)
{
	Database& db = from -> GetDatabase();
	Player pl(db, from -> GetAccountName());
	Area area(db, pl.GetArea());
	Chunk chunk(db, area, pl.GetChunk());
	int x = pl.GetChunkX();
	int y = pl.GetChunkY();

	if (from -> GetMoveEvent())
	{
		from -> BufferMove("enter");
	}
	else
	{
		if (chunk.Get(x, y) == 'P')
		{
			Portal info(db, chunk, x, y);
			if (info.Exists())
			{
				pl.SetArea(info.GetToArea());
				pl.SetChunk(info.GetToChunk());
				pl.SetChunkX(info.GetToX());
				pl.SetChunkY(info.GetToY());
				if (!params.size())
				{
					Look::LookMap(from);
				}
				Look::Show(from);
				from -> SetMoveEvent(0, 1000);
			}
			else
			{
				from -> Send("Huh - Portal terrain without Chunkinfo\n");
				from -> CancelMoves();
			}
		}
		else
		{
			from -> Send("No portal here.\n");
			from -> CancelMoves();
		}
		from -> SetPrompt();
	}
}


