// Forward.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "Forward.h"
#include "Player.h"
#include "InSocket.h"
#include "Look.h"
#include "North.h"
#include "South.h"
#include "East.h"
#include "West.h"
#include "FutureHandler.h"


void Forward::Execute(InSocket *from,const std::string& params,Parse& pa)
{
	if (from -> GetMoveEvent())
	{
		from -> BufferMove("forward");
	}
	else
	{
		Player pl(from -> GetDatabase(),from -> GetAccountName());
		Command *cc = NULL;
		if (!pl.GetFacing())
			pl.SetFacing(1);
		switch (pl.GetFacing())
		{
		case 1: // north
			cc = static_cast<FutureHandler&>(from -> Handler()).GetCommand("north");
			break;
		case 2: // south
			cc = static_cast<FutureHandler&>(from -> Handler()).GetCommand("south");
			break;
		case 3: // east
			cc = static_cast<FutureHandler&>(from -> Handler()).GetCommand("east");
			break;
		case 4: // west
			cc = static_cast<FutureHandler&>(from -> Handler()).GetCommand("west");
			break;
		}
		if (cc)
		{
			cc -> Execute(from, params, pa);
			return;
		}
		from -> Send("Not OK.\n");
		from -> SetPrompt();
	}
}


