// FutureHandler.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _FUTUREHANDLER_H
#define _FUTUREHANDLER_H

//#include <SocketHandler.h>
#include <EventHandler.h>
#include <sqlite3.h>
#include <libsqlitewrapped.h>


class InSocket;
class Command;
class Login;
class Event;
class IEventOwner;

/** \defgroup system Networking and events */
/** SocketHandler implementation.
	\ingroup system */
class FutureHandler : public EventHandler
{
public:
	FutureHandler();
	~FutureHandler();

	Database& GetDatabase() { return m_db; }

	void DoCommand(InSocket *,const std::string& cmd,const std::string& params);
	void Talk(InSocket *,const std::string&);
	void ShowHelp(InSocket *,const std::string&);

	void GlobalEvent(InSocket *,const std::string& );

	std::map<SOCKET,Socket *>& Sockets() { return m_sockets; }
	Login *GetLogin() { return m_login; }

	void Count(const std::string& event);
	std::string GetDateTime();

	Command *GetCommand(const std::string& );

private:
	std::list<Command *> m_command;
	Database m_db;
	Login *m_login;
};




#endif // _FUTUREHANDLER_H
