// Go.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <Parse.h>

#include "Go.h"
#include "InSocket.h"
#include "Chunk.h"
#include "Player.h"
#include "Terrain.h"
#include "Area.h"


void Go::Execute(InSocket *from,const std::string& params,Parse& pa)
{
	int a = atoi(params.c_str());
	int x = pa.getvalue();
	int y = pa.getvalue();
	int z = pa.getvalue();
	Database& db = from -> GetDatabase();
	Area area(db, a);
	if (area.Exists())
	{
		Chunk chunk(db, area, x, y, z);
		if (chunk.Exists())
		{
			Player pl(db, from -> GetAccountName());
			from -> Send("Ok.\n");
			pl.SetArea(area.GetNum());
			pl.SetChunk(chunk.GetNum());
		}
		else
		{
			from -> Send("No chunk\n");
		}
	}
	else
	{
		from -> Send("No area\n");
	}
	from -> SetPrompt();
}


