// List.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>
#include <libfuture.h>
#include <Parse.h>
#include <Utility.h>

#include "List.h"
#include "InSocket.h"
#include "Player.h"
#include "Area.h"


void List::Execute(InSocket *from,const std::string& param,Parse& pa)
{
	Database& db = from -> GetDatabase();
	Query q(db);
	if (param == "terrain")
	{
		Player pl(db, from -> GetAccountName());
		Area area(db, pl.GetArea());
		q.get_result("select * from terrain where area=" + Utility::l2string(area.GetNum()));
		while (q.fetch_row())
		{
			db::Terrain t(&db, &q);
			from -> Send(t.tcolor + t.tchar + "&n    " + t.name + (t.impassable ? "    (Impassable)" : "") + "\n");
		}
		q.free_result();
	}
	else
	if (param == "wizards")
	{
		q.get_result("select * from account where wizard<>0");
		while (q.fetch_row())
		{
			db::Account x(&db, &q);
			from -> Send("  " + x.display_name + "\n");
		}
		q.free_result();
	}
	else
	if (param == "areas")
	{
		q.get_result("select * from area");
		while (q.fetch_row())
		{
			db::Area area(&db, &q);
			from -> Sendf("#%ld: %2ldx%2ld %s\n", area.num, area.width, area.height, area.name.c_str());
		}
		q.free_result();
	}
	else
	{
		from -> Send("List what?\n");
	}
	from -> SetPrompt();
}


