// Main.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <ListenSocket.h>
#include "FutureHandler.h"
#include "InSocket.h"
#include "HeartBeat.h"


void add(SocketHandler& h,int port)
{
	ListenSocket<InSocket> *l = new ListenSocket<InSocket>(h);
	printf("Attempting bind on port %d... ", port);
	if (l -> Bind(port))
	{
		printf("Not successful\n");
		delete l;
		return;
	}
	printf("OK\n");
	l -> SetDeleteByHandler();
	h.Add(l);
}


int main(int argc,char *argv[])
{
	int port = 4040;
	if (argc > 1)
		port = atoi(argv[1]);
	FutureHandler h;
	add(h, port);
	add(h, 4040);
	add(h, 4441);
	add(h, 8080);
	add(h, 4442);
	//
//	printf("Ready\n");
	HeartBeat beat(h);
	h.EventLoop();
/*
	while (true)
	{
		struct timeval tv;
		if (h.GetTimeUntilNextEvent(&tv))
		{
			h.Select(&tv);
			h.CheckEvents();
		}
		else
		{
			h.Select();
		}
	}
*/
}


