// Move.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _MOVE_H
#define _MOVE_H

#include "Command.h"


class Chunk;
class InSocket;

/** Movement command base class
	\ingroup command */
class Move : public Command
{
public:
	Move(const std::string& x,char y,int loc_x,int loc_y,bool wiz = false) : Command(x, y, wiz)
	, m_loc_x(loc_x), m_loc_y(loc_y) {}

	void move_to(InSocket *from,Chunk& north,int ny_x,int ny_y,bool hide_map);
	void try_move(InSocket *from, int ch_x, int ch_y, int ch_z, bool hide_map);
	void try_create(InSocket *from,const std::string& line,int ch_x,int ch_y,int ch_z);

private:
	int m_loc_x;
	int m_loc_y;
};


#endif // _MOVE_H
