// Portal.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <libfuture.h>

#include "Portal.h"
#include "Player.h"
#include "InSocket.h"


Portal::Portal(Database& db,Chunk& chunk) : Chunkinfo(db, chunk)
{
}


Portal::Portal(Database& db,Chunk& chunk,int x,int y) : Chunkinfo(db, chunk, x, y, TYPE_PORTAL)
{
}


Portal::~Portal()
{
}


void Portal::SetToArea(int x)
{
	m_chunkinfo -> to_area = x;
}


void Portal::SetToChunk(int x)
{
	m_chunkinfo -> to_chunk = x;
}


void Portal::SetToX(int x)
{
	m_chunkinfo -> to_x = x;
}


void Portal::SetToY(int x)
{
	m_chunkinfo -> to_y = x;
}


int Portal::GetToArea()
{
	return m_chunkinfo -> to_area;
}


int Portal::GetToChunk()
{
	return m_chunkinfo -> to_chunk;
}


int Portal::GetToX()
{
	return m_chunkinfo -> to_x;
}


int Portal::GetToY()
{
	return m_chunkinfo -> to_y;
}


void Portal::Display(InSocket *from)
{
	if (!Exists())
		return;
	Player pl(from -> GetDatabase(),from -> GetAccountName());
	from -> Send("  You see a portal.\n");
	if (pl.IsWizard())
	{
		from -> Sendf("  [&gToArea:&W%ld&n  &gToChunk:&W%ld&n  &gToX:&W%d&n  &gToY:&W%d&n]\n",
			GetToArea(), GetToChunk(), GetToX(), GetToY());
	}
}


