// Race.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _RACE_H
#define _RACE_H

#include "Object.h"


class Database;
namespace db { class Race; }
class InSocket;

typedef std::map<std::string,db::Race *> races_t;

/** Database table Race
	\ingroup db */
class Race : public Object
{
public:
	Race(Database&, long num);
	Race(Database&, const std::string& );
	~Race();

	bool Exists();
	void Save();
	long GetNum();

	void SetName(const std::string& );
	const std::string& GetName();
	void SetSightRange(double);
	double GetSightRange();
	void SetHearing(double);
	double GetHearing();

static	int DisplayRaces(InSocket *);

private:
static	db::Race *GetRace(Database& ,long num);
static	db::Race *GetRace(Database& ,const std::string&);
static	races_t m_cache;
	db::Race *m_race;
};




#endif // _RACE_H
