// Set.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <Parse.h>

#include "Set.h"
#include "InSocket.h"
#include "Chunk.h"
#include "Player.h"
#include "cstring.h"
#include "Terrain.h"
#include "Area.h"
#include "Look.h"


void Setcmd::Execute(InSocket *from,const std::string& param,Parse& pa)
{
	Database& db = from -> GetDatabase();
	Player pl(db, from -> GetAccountName());
	std::string rest = pa.getrest();
	if (param == "wizard" && pl.IsWizard())
	{
		Player a(db, rest);
		if (a.Exists())
		{
			a.SetWizard(!a.IsWizard());
			a.Save();
			from -> Send(a.GetDisplayName() + " is now" + (a.IsWizard()?"":" NOT") + " a wizard.\n");
		}
		else
		{
			from -> Send("Can't find " + rest + ".\n");
		}
		from -> SetPrompt();
	}
	else
	if (param == "terrain" && pl.IsWizard())
	{
		if (rest.size())
		{
			Area area(db, pl.GetArea());
			Terrain t(db, area, rest[0]);
			if (t.Exists())
			{
				Chunk chunk(db, area, pl.GetChunk());
				chunk.Set(pl.GetChunkX(),pl.GetChunkY(),t.GetChar());
				chunk.Save();
				from -> Send("Ok.\n");
			}
			else
			{
				from -> Send("Can't find terrain " + rest + ".\n");
			}
		}
		else
		{
			from -> Send("Set terrain?\n");
		}
		from -> SetPrompt();
	}
	else
	if (param == "name")
	{
		if (rest.size())
		{
			cstring name = rest;
			if (!strcmp(name.uc_str(), pl.GetName().c_str()))
			{
				pl.SetDisplayName(rest);
				from -> Send("Ok.\n");
			}
			else
			{
				from -> Send("Name mismatch, please try again.\n");
			}
		}
		else
		{
			from -> Send("Set your name to what?\n");
		}
		from -> SetPrompt();
	}
	else
	if (param == "view")
	{
		if (rest.size() && (rest[0] == 'w' || rest[0] == 'W'))
		{
			Player pl(db, from -> GetAccountName());
			pl.SetWizView(1);
		}
		else
		{
			pl.SetWizView(0);
		}
		Look::LookMap(from);
		from -> SetPrompt();
	}
	else
	{
		from -> Send("Set what?\n");
		from -> SetPrompt();
	}
}


