// Steps.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <libfuture.h>
#include <Utility.h>
#include <Parse.h>

#include "Steps.h"
#include "Player.h"
#include "Area.h"


// statics
steps_t Steps::m_cache;

Steps::Steps(Database& db,Player& pl,Area& area,long z,long y)
:Object(db)
,m_player(pl)
,m_area(area)
{
	m_steps = Steps::GetSteps(db, pl, area, z, y);
}


Steps::~Steps()
{
}


db::Steps *Steps::GetSteps(Database& db,Player& pl,Area& area,long z,long y)
{
	db::Steps *p = m_cache[pl.GetNum()][area.GetNum()][z][y];
	if (p)
		return p;
	p = new db::Steps(db, pl.GetNum(), area.GetNum(), z, y);
	p -> player = pl.GetNum();
	p -> area = area.GetNum();
	p -> zcoord = z;
	p -> ycoord = y;
	m_cache[pl.GetNum()][area.GetNum()][z][y] = p;
	return p;
}


void Steps::AddCoord(long x)
{
	Parse pa(m_steps -> xcoords, ":");
	std::string tmp = pa.getword();
	while (tmp.size())
	{
		if (atol(tmp.c_str()) == x)
			return;
		//
		tmp = pa.getword();
	}
	if (m_steps -> xcoords.size())
	{
		m_steps -> xcoords += ":" + Utility::l2string(x);
	}
	else
	{
		m_steps -> xcoords = Utility::l2string(x);
	}
	Save();
}


void Steps::Save()
{
	m_steps -> save();
}


bool Steps::Exists()
{
	if (m_steps && m_steps -> num)
		return true;
	return false;
}


long Steps::GetNum()
{
	return m_steps -> num;
}


db::Steps *Steps::GetStep(Player& pl,Area& area,long z,long y)
{
	return m_cache[pl.GetNum()][area.GetNum()][z][y];
}


