// Steps.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _STEPS_H
#define _STEPS_H

#include "Object.h"
#include <map>
#include <list>


class Player;
class Area;
namespace db { class Steps; }

typedef std::map<long,db::Steps *> ycoord_m;
typedef std::map<long,ycoord_m> zcoord_m;
typedef std::map<long,zcoord_m> area_m;
typedef std::map<long,area_m> steps_t; //player_m;

/** Database table Steps
	\ingroup db */
class Steps : public Object
{
public:
	Steps(Database& ,Player& ,Area& ,long z,long y);
	~Steps();

	void Save();
	bool Exists();
	long GetNum();

	void AddCoord(long x);

static	db::Steps *GetStep(Player&,Area&,long z,long y);

private:
static	db::Steps *GetSteps(Database& ,Player& ,Area& ,long z,long y);
static	steps_t m_cache;
	Player& m_player;
	Area& m_area;
	db::Steps *m_steps;
};




#endif // _STEPS_H
