// Terrain.h
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _TERRAIN_H
#define _TERRAIN_H

#include "Object.h"


namespace db { class Terrain; }
class Area;

typedef std::map<long,std::map<char,db::Terrain *> > terrains_t;

class Database;

/** Database table Terrain
	\ingroup db */
class Terrain : public Object
{
public:
	Terrain(Database& ,Area& ,char tchar);
	~Terrain();

	bool Exists();
	void Save();

	const std::string& GetColor();
	void SetColor(const std::string&);
	const std::string& GetName();
	void SetName(const std::string&);
	char GetChar();
	void SetChar(char tchar);
	bool IsImpassable();
	void SetImpassable(bool = true);
	long GetNum();
	double GetDelay();
	void SetDelay(double);

static	db::Terrain *GetTerrain(Database&, Area& ,char tchar);

private:
	Area& m_area;
static	terrains_t m_terrains;
	db::Terrain *m_terrain;
};




#endif // _TERRAIN_H
