// Who.cpp
// released 2006-09-25
/*
Copyright (C) 2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>
#include <map>

#include "Who.h"
#include "InSocket.h"
#include "FutureHandler.h"
#include "Player.h"


void Who::Execute(InSocket *from,const std::string& params,Parse& pa)
{
	Database& db = from -> GetDatabase();
	std::map<SOCKET,Socket *>& ref = static_cast<FutureHandler&>(from -> Handler()).Sockets();
	for (std::map<SOCKET,Socket *>::iterator it = ref.begin(); it != ref.end(); it++)
	{
		Socket *p0 = (*it).second;
		InSocket *p = dynamic_cast<InSocket *>(p0);
		if (p)
		{
			Player pl(db, p -> GetAccountName());
			from -> Send(pl.GetDisplayName() + "\n");
		}
	}
	from -> SetPrompt();
}





