BEGIN TRANSACTION;
DELETE FROM sqlite_sequence;
CREATE TABLE account ( num integer primary key autoincrement not null,
name varchar(255) default '' not null,
passwd varchar(255) default '' not null,
display_name varchar(255) default '' not null,
wizard tinyint(1) default 0 not null, email varchar(255) default '' not null, area integer default 0 not null, chunk integer default 0 not null, chunkx integer default 0 not null, chunky integer default 0 not null, facing integer default 0 not null, wizview integer default 0 not null, race integer default 0 not null,
unique(name));
CREATE TABLE eventcount ( num integer primary key autoincrement not null,
event_name varchar(255) default '' not null,
count integer default 0 not null,
unique(event_name));
CREATE TABLE area ( num integer primary key autoincrement not null,
name varchar(255) default '' not null,
width integer,
height integer,
unique(name));
CREATE TABLE chunk ( num integer primary key autoincrement not null,
area integer default 0 not null,
terrain text,
x integer,
y integer,
z integer, created_by integer default 0 not null, created_date datetime default '' not null,
unique(area,x,y,z));
CREATE TABLE chunkinfo ( num integer primary key autoincrement not null,
chunk integer default 0 not null,
type integer default 0 not null,
x integer default 0 not null,
y integer default 0 not null,
data varchar(255), to_area integer, to_chunk integer, to_x integer, to_y integer,
unique(chunk,type,x,y));
CREATE TABLE terrain ( num integer primary key autoincrement not null,
area integer default 0 not null,
name varchar(255) default '' not null,
tchar char(1),
tcolor varchar(10), impassable integer default 0 not null, delay float default 0 not null,
unique(area,tchar));
CREATE TABLE steps ( num integer primary key autoincrement not null,
player integer default 0 not null,
area integer default 0 not null,
zcoord integer default 0 not null,
ycoord integer default 0 not null,
xcoords text,
unique(player,area,zcoord,ycoord));
CREATE TABLE race ( num integer primary key autoincrement not null,
name varchar(255) default '' not null,
sightrange float,
hearing float,
unique(name));
CREATE INDEX chunk_area on chunk(area);
COMMIT;
